#include<avr/io.h>

int x=0;


//1. PHASENKORR. PWM-Signal:

//fpwm = fclk / (2*N*TOP)

//fclk = 16.000.000Hz
//fpwm = 50...100Hz
//
//   N = fclk/(fpwm*2*TOP) = 16000000/(75*2*1023) = 104,...

//N=64 =>
//fpwm = 16000000 / (2*256*1023) = 30Hz FALSCH

//Besser: 9Bit Aufl. und Vorteilung 256:
//MODE 2 von Seite 121 Datenblat ATmega32U4:
//WGM13 WGM12 WGM11 WGM10
//  0     0     1     0
//COM1A1  COM1A0
//  1       0
//  1       1  (wahrscheinlicher)
//CS12  CS11  CS10
//  1     0    0    //fclk durch 256 teilen

//TCCR1B |= (0<<WGM13) | (0<<WGM12) | (1<<CS12) | (0<<CS11) | (0<<CS10) ;
//TCCR1A |= (1<<COM1A1) | (1<<COM1A0) | (1<<WGM11) | (0<<WGM10);
//fpwm = 16000000 / (2*256*511) = 61,154598826Hz O.K.

//2. Fast PWM

//N=64 =>
//fpwm = 16000000 / (256*1023) = 61,154598826Hz O.K.

//3. TOP vorzugeben und ev. mit 16Bit Aufl. arbeiten 
//BESTE Möglichkeit

//**** LED dimmen testen ****

void setup() 
{ 
  
  //Mode 2: 9Bit Phasen korrekt PWM
  //DDRB |= (1<<PB5);
  //TCCR1B |= (0<<WGM13) | (0<<WGM12) | (1<<CS12) | (0<<CS11) | (0<<CS10) ;
  //TCCR1A |= (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (1<<WGM11) | (0<<WGM10);
//TIMSK1 |= (1<<OCIE1A) | (1<<OCIE1B) |(1<<TOIE1);

  //KEIN ODER-GLEICH, da nicht gewährleistet ist, dass die Initialisierung laut Datenblatt bei
  //Arduino gilt:
  //Arduino hat eine eigene Initialisierung, die hier überschreiben werden muß und zwar in jedem Bit
  //des jeweiligen Registers

  TCCR1B = (0<<WGM13) | (0<<WGM12) | (1<<CS12) | (0<<CS11) | (0<<CS10) ;
  TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (1<<WGM11) | (0<<WGM10);

  
  DDRB |= (1<<PB5);
} 

void loop() 
{
    
  
  
    if(x<512)
        OCR1A = x;
    else
        OCR1A = 1022-x;
    delay(6);
    x++;
    x%=1023;
} 
